' EduMite.bas for EduMite PCB: FONT 1 is 60x26; FONT7 is 80x40

Option explicit
Dim integer i,j,k,l,m,n,iCol,iRow,iPass,x,y,iBtnFG,iBtnBG,kBtnBG=RGB(red),kBtnFG=RGB(yellow)
Dim integer iFG,iBG
Dim integer fH,fW,iFont,nChRow,nRows,lastSW,iRotVal,iRotMin=1,iRotMax=16,lastRotVal
Dim string a,c,e,f,g,h,s,sLDR,sLastLDR,lastSecond$,SWonoff(1)=(" ON","OFF")
Dim float fLDR,fPOT,fTMP,fHUM,fDSTMP, fLastLDR,fLastPOT,fLastTMP,fLastDSTMP,fLastHum
dim integer iRE_SW, lastRE_SW, pin0,pin1 ' used in Rotary Encoder interrupt
Dim integer d%(15),b%(15)=(RGB(red), RGB(green), RGB(blue),0,0,0,0,0,0,0,0,0,0,0,0,0)
b%(3)=RGB(Yellow): b%(4)=RGB(cyan)
b%(5)=RGB(gold): b%(6)=RGB(magenta): b%(7)=RGB(brown): b%(8)=RGB(pink)
b%(9)=RGB(salmon): b%(10)=RGB(orange):b%(11)=RGB(grey):b%(12)=RGB(white)
b%(13)=RGB(lightgrey): b%(14)=RGB(beige): b%(15)=0 ' black
Const false=0
Const true=1

Dim integer rotatedright=false, rotatedleft=false, resetenc=true

Dim integer tickState, tick, lastTick, fastTick, lastFast
' define pin numbers
Const pCOM1Tx=1,pCOM1Rx=2,pRG_G=1,pRG_R=2,pBUZZER=4,pSERVO=5,pRGB_G=6,pRGB_B=7,pPUSHBTN=9
Const pPS2_C=11,pPS2_D=12,pRE_C=14,pRE_D=15,pRE_SW=16,pHUMID=17,pDS18B20=19
Const pWS2812=20,pPOT=31,pLDR=32,pRGB_R=34
CONST pTraf_Y=7, pTraf_R=34, pTraf_G=6 ' NOTE: Duplicates pRBB_R,G,Y
Const cTurquoise=RGB(64,224,208),cBlack=0

init:
SetPin pCOM1Tx,dout: SetPin pCOM1Rx,dout ' if used for LEDs, not serial
SetPin pRGB_R,dout: SetPin pRGB_G,dout: SetPin pRGB_B,dout
SetPin pBUZZER,dout: SetPin pPUSHBTN,din,pullup
SetPin pLDR,ain: SetPin pPOT,ain: setpin pServo,pwm1b

SetPin pRE_C,intB,RE_int 'enable interrupts on both edges of both pins
SetPin pRE_D,intB,RE_int
SetPin pRE_SW,din,pullup

TEMPR START pDS18B20
iFont=7
Font iFont
fH=MM.Info(FONTHEIGHT): fW=MM.Info(FONTWIDTH)
nChRow=MM.HRes/fW: nRows=MM.VRes/fH
Print "Font ";iFont;"; width, height, chars/row: ";fW;" ";fH;" ";nChRow;"x";nRows
iBG=cTurquoise ' RGB(red)
iFG=RGB(white)
CLS iBG
For i=0 To 3 ' print 16 boxes using predefined colors
  For j=0 To 3
    Box i*80,j*40,75,38,0,,b%(j*4+i)
  Next j
Next i
pin(pRG_G)=1 ' initialize R/G Led for toggling
Pause 1000

MAIN:
  Do
    a=Mid$(Time$,7,2)
    If a<>lastSecond$ Then
      lastSecond$=a
      inc iPass
      fDSTMP=TEMPR(pDS18B20)
      If fLastDSTMP<>fDSTMP Then
        Text 10,fH*22,"DS18B20 Temp: "+Str$(fDSTMP,2,1),,2,,iFG,iBG
        fLastDSTMP=fDSTMP
      EndIf
      TEMPR START pDS18B20
      Bitbang humid pHUMID,fTMP,fHUM
      If fLastTMP<>fTMP Then
        Text 10,fH*24,"DHT22 Temp: "+Str$(fTMP,2,1),,2,,iFG,iBG
        fLastTMP=fTMP
      EndIf
      If fLastHUM<>fHUM Then
        Text 10,fH*26,"Humidity: "+Str$(fHUM,2,1),,2,,iFG,iBG
        fLastHUM=fHUM
      EndIf
      fLDR=Pin(pLDR)
      sLDR=str$(fLDR,1,1)
      If sLastLDR<>sLDR Then
        sLastLDR=sLDR
        Text 10,fH*30,"LDR: "+sLDR,,2,,iFG,iBG
      EndIf
      i=Pin(pPUSHBTN)
      If lastSW<>i Then
        LastSW=i
        Text 10,fH*32,"Pushbutton: "+SWonoff(LastSW),,2,,iFG,iBG
      EndIf
      pin(pRG_G)=1-pin(pRG_G):pin(pRG_R)=1-pin(pRG_R)
      if d%(0)=b%(3) and LastSW=0 then: pin(pBUZZER)=1-pin(pBUZZER) ' toggle buzzer if yellow
      else: pin(pBUZZER)=0: endif
      i = iPass mod 4
      select case i ' sequence through traffic light LEDs
        case 0: pin(pTraf_R)=0
        case 1: pin(pTraf_G)=1
        case 2: pin(pTraf_G)=0: pin(pTraf_Y)=1
        case 3: pin(pTraf_Y)=0: pin(pTraf_R)=1
      end select
      if lastRotVal<>iRotVal then
        lastRotVal=iRotVal
        lastRE_SW=1 ' turn on the WS2812 lights
        Text 10,fH*34,"Rotary Encoder: "+Str$(iRotVal,2),,2,,iFG,iBG
        for i=0 to 15: d%(i)=b%(iRotVal-1): next i ' set WS2812 color based on Rotary Encoder
        Bitbang ws2812 b,pWS2812,16,d%()
      endif
      if pin(pRE_SW)=0 then ' pulled up is off; depressed is 0
        if lastRE_SW=1 then ' turn off the WS2812 lights
          lastRE_SW=0
          lastRotVal=0
          iRotVal=0
          Text 10,fH*34,"Rotary Encoder: "+Str$(iRotVal,2),,2,,iFG,iBG
          for i=0 to 15: d%(i)=0: next i ' set WS2812 colors off (black)
          Bitbang ws2812 b,pWS2812,16,d%()
        endif
      endif ' turned back on if Rotary Encoder is turned)
    EndIf ' once a seconde

    fPOT=Pin(pPOT)
    If fLastPOT<>fPOT Then
      Text 10,fH*28,"Potentiometer: "+Str$(3.3-fPOT,1,2),,2,,iFG,iBG
      fLastPOT=fPOT
' matherp re servo: PWM n,50,(position_as_a_percentage * 0.05 + 5)
      PWM 1,50,,fPot/.033*.05+5 ' swing (pServo--5--pwm1b)
    EndIf
  Loop

Sub RE_int ' rotary encoder interrupt
' code: https://www.thebackshed.com/forum/ViewTopic.php?TID=10568&PID=124755#124755
' from matherp & goc
'  Local integer pin0,pin1
rint2:
  pin0=Not Pin(pRE_C) 'reverse sense to get positive logic
  pin1=Not Pin(pRE_D)
  If pin0 Then
    If pin1 And Not resetenc Then 'pRE_C and pRE_D both active
      If rotatedleft And Not rotatedright Then
        iRotVal=Fix(Max(1,iRotVal-1)) ' minimum of 1
        rotatedleft=false
      EndIf
      If rotatedright And Not rotatedleft Then
        iRotVal=Fix(Min(iRotMax,iRotVal+1))
        rotatedright=false
      EndIf
    Else 'only pRE_C active
      If resetenc And Not rotatedleft Then
        rotatedright=true
        resetenc=false
      EndIf
    EndIf
  Else
    If pin1 Then 'only pRE_D active
      If resetenc And Not rotatedright Then
        rotatedleft=true
        resetenc=false
      EndIf
    Else 'both off so reset
      rotatedleft=false
      rotatedright=false
      resetenc=true
    EndIf
  EndIf
  If Pin(pRE_C)=pin0 Or Pin(pRE_D)=pin1 Then
    GoTo rint2 're-enter if another change has happened almost immediately
  EndIf
End Sub
